require("class");
require("vector2");
require("colors");
require("ball");

screenSize = Vector2(650, 650);
BallList = {};

--#LOAD#LOAD#LOAD#LOAD#LOAD#LOAD#LOAD#LOAD#LOAD#LOAD#LOAD#LOAD#LOAD#LOAD#
function love.load()
	love.graphics.setBackgroundColor(Colors.slateGray);
	--fullscreen, vsync, fsaa, resizable, borderless, centered
	local flags = {false, true, 0, true, false, true};
	love.graphics.setMode(screenSize.x, screenSize.y, flags);
	love.graphics.setDefaultImageFilter("nearest", "nearest");
	
	table.insert(BallList, Ball(Vector2(50, 50), Vector2(0.2, 0.1), 25));
	table.insert(BallList, Ball(Vector2(100, 200), Vector2(-0.3, 0.27), 25));
	table.insert(BallList, Ball(Vector2(150, 250), Vector2(0.1, 0.2), 25));
	table.insert(BallList, Ball(Vector2(200, 400), Vector2(0.6, -0.15), 25));
	table.insert(BallList, Ball(Vector2(150, 50), Vector2(0.2, 0.1), 25));
	table.insert(BallList, Ball(Vector2(200, 200), Vector2(-0.3, 0.27), 25));
	table.insert(BallList, Ball(Vector2(250, 250), Vector2(0.1, 0.2), 25));
	table.insert(BallList, Ball(Vector2(300, 400), Vector2(0.6, -0.15), 25));
end

--#UPDATE#UPDATE#UPDATE#UPDATE#UPDATE#UPDATE#UPDATE#UPDATE#UPDATE#UPDATE#
function love.update(dt)
	local scalar = dt * 1200;

	for i = 1, #BallList do
		BallList[i].color = Colors.white;
	end
	for i = 1, #BallList do
		BallList[i]:Update(scalar);
		
		for i2 = i + 1, #BallList do
			if (distanceVector2(BallList[i].position, BallList[i2].position) < BallList[i].radius + BallList[i2].radius) then
				BallList[i].color = Colors.red;
				BallList[i2].color = Colors.red;
				
				BallList[i]:resolveCollision(BallList[i2]);
			end
		end
	end
end

--#DRAW#DRAW#DRAW#DRAW#DRAW#DRAW#DRAW#DRAW#DRAW#DRAW#DRAW#DRAW#DRAW#DRAW#
function love.draw()
	for i = 1, #BallList do
		BallList[i]:Draw();
	end
end